/*
Hello World-program for an HD44780 LCD
*/
#define F_CPU 1000000
#include <avr/io.h>
#include <util/delay.h>

//Define the LCD pins. D0-D7 of the LCD aren't going to be defined here because
//we talk to them as the 8-bit 'bus' that is PORTD.
#define LCD_RS	PB6
#define LCD_RW	PB7
#define LCD_E	PB0

//LCD routine: send a command to the LCD
void LCDCommand(char cmd) {
	//Write Me!
}

//LCD routine: send data to the LCD
void LCDData(char data) {
	//Write Me!
}

//Main routine. The program starts here.
int main(void) {
	//Make all pins going to the LCD into outputs
	DDRD=0xFF; //0xff = all 1s
	DDRB=(1<<LCD_E)|(1<<LCD_RS)|(1<<LCD_RW);
	
	//Initialize the LCD. (See page 14 of the file
	//1260_LCD_display_2x16.pdf for the explanation)
	_delay_ms(15);
	LCDCommand(0x38); //=0b00111000, 'Function Set'
	LCDCommand(0x0F); //=0000001111, 'Display on/off control'
	LCDCommand(0x01); //=0b00000001, 'Display Clear'
	LCDCommand(0x06); //=0b00000110, 'Entry mode set'
	
	//Send 'Hello'
	LCDData('H');
	LCDData('e');
	LCDData('l');
	LCDData('l');
	LCDData('o');
	
	//Sending strings in this fashion can take all day. This is quicker:
	char myString[]=", world!";
	int x;
	//Iterate past all eight characters in the string
	for (x=0; x<8; x++) {
		LCDData(myString[x]);
	}
	
	//And now, if you've done everything correct, you should have an LCD with 
	//'Hello, World' on it. Congratulations!
}

